#!/usr/bin/perl --

#-----------------------------------------------------------------#
# MemberMap 4 Converter                                           #
# for YaBB 2                                                      #
# by Carsten Dalgaard                                             #
#-----------------------------------------------------------------#
# Copyright: 2004 'Carsten Dalgaard' - All Rights Reserved        #
# Released: December 10, 2004                                     #
# e-mail: post@cd-profil.dk                                       #
#-----------------------------------------------------------------#
# Any redistribution of this script without the expressed written #
# consent of 'cd-profil as' is strictly prohibited. Copying any   #
# of the code contained within this script and claiming it as     #
# your own is also prohibited.                                    #
#-----------------------------------------------------------------#
# By using this script you agree to indemnify 'Carsten Dalgaard'  #
# from any liability that might arise from its use.               #
#-----------------------------------------------------------------#
# You may not remove any of these header notices.                 #
#-----------------------------------------------------------------#

push(@INC, "./Modules");

if ($ENV{'SERVER_SOFTWARE'} =~ /IIS/) {
	$yyIIS = 1;
	$0 =~ m~(.*)(\\|/)~;
	$yypath = $1;
	$yypath =~ s~\\~/~g;
	chdir($yypath);
	push(@INC, $yypath);
}

$script_root = $ENV{'SCRIPT_FILENAME'};
$script_root =~ s/\/YaBB\.(pl|cgi)//ig;

if (-e "Paths.pl") { require "Paths.pl"; }
elsif (-e "$script_root/Paths.pl") { require "$script_root/Paths.pl"; }

if(-e "$vardir/Settings.pl") { require "$vardir/Settings.pl"; }
elsif(-e "Settings.pl") { require "Settings.pl"; }
require "$sourcedir/Subs.pl";
require "$sourcedir/System.pl";
require "$sourcedir/Load.pl";
require "$sourcedir/DateTime.pl";
LoadLanguage("Main");
&ConvertLocation;
&output;
exit;

sub ConvertLocation {
opendir(MEMBERS, $memberdir);
@contents = grep {/\.vars$/} readdir(MEMBERS);
closedir(MEMBERS);
$converted = "";
foreach $member (@contents){
	$member =~ s/\.vars$//g;
	if ($member) { 
		chomp $member;
		&UserCheck($member,"location");
		if ($usercheck{'location'}) {
			my($location, $country, $state, $mapselect, $xcoord, $ycoord);
			$locode = substr($usercheck{'location'},0,3);
			if($locode eq "x1|" || $locode eq "x0|") {
				&LoadUser($member);
				($dummy, $location, $country, $mapselect, $xcoord, $ycoord, $state) = split(/\|/, $usercheck{'location'});
				if($mapselect eq "usa") { $mapselect = "USA" }
				${$uid.$member}{'location'} = "$location";
				$mapped = "No";
				if($xcoord && $ycoord) {
					${$uid.$member}{'country'} = ucfirst $country;
					${$uid.$member}{'state'} = $state;
					${$uid.$member}{'map'} = ucfirst $mapselect;
					${$uid.$member}{'xcoord'} = $xcoord - 3;
					${$uid.$member}{'ycoord'} = $ycoord - 1;
					$mapped = "Yes";
				}
				&UserAccount($member,"update");
				$converted .= qq~<tr><td>&nbsp;$member</td><td>&nbsp;${$uid.$member}{'location'}</td><td>&nbsp;${$uid.$member}{'state'}</td><td>&nbsp;${$uid.$member}{'country'}</td><td>&nbsp;${$uid.$member}{'map'}</td><td align="center">$mapped</td></tr>~;
			}
		}
	}
}
}

sub output {
	if($yySetCookies1 || $yySetCookies2) { print header(-status=>"200 OK", -cookie=>[$yySetCookies1, $yySetCookies2], -charset=>$yycharset); }
	else { print header(-status=>"200 OK", -charset=>$yycharset); }
	print qq~
	<!DOCTYPE html PUBLIC "-//W3C//DTD Xhtml 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
	<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
	<head>
	<title>$yytitle</title>
	<meta http-equiv="Content-Type" content="text/html; charset=$yycharset" />
	</head>
	<body style="font-family: verdana; font-size: 10px;">
	<table cellspacing="0" cellpadding="3" border="1" align="center" bordercolor="#000000">
	<tr><td colspan="6" style="color: #ffffff; background-color: #000000;"><b>Conversion from old MemberMap location style to new hash format completed!</b></td></tr>
	<tr><td align="center"><b>User</b></td><td align="center"><b>Location</b></td><td align="center"><b>State/Region</b></td><td align="center"><b>Country</b></td><td align="center"><b>Map</b></td><td align="center"><b>On Map</b></td></tr>
	$converted
	</table>
	</body>
	</html>~;
exit;
}

1;